#! /usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = __importDefault(require("commander"));
const modules_1 = require("./commands/modules");
commander_1.default
    .option('-i, --installed', 'List currently installed modules')
    .option('-j, --json', 'List raw JSON information')
    .description('list module information')
    .parse(process.argv);
let opts = commander_1.default.opts();
let modCommand = new modules_1.ModuleCommand();
if (opts.installed)
    console.log(modCommand.listInstalledModules());
else if (opts.json)
    console.log(modCommand.listInstallModulesJson());
else if (opts.available)
    console.log('TODO: list available modules for installation');
else
    console.log(modCommand.listInstalledModules());
