#! /usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = __importDefault(require("commander"));
const ramda_1 = __importDefault(require("ramda"));
const exec_1 = require("./commands/exec");
const version_1 = require("./commands/version");
commander_1.default
    .option("-v, --version", "output the version number", () => {
    let v = new version_1.VersionCommand();
    console.log(v.getVersions());
})
    .option('-o, --skipOutputTS', 'Output Typescript file')
    .option('-l, --skipLinting', 'Lint Output Typescript file')
    .option('-s, --skipRun', 'Skip running the program')
    .option('-d, --outputDir <path>', 'Working directory path for logs and temp files')
    .description('******************************************** ' + '\n' +
    "   ____  ____    ____            _       _" + '\n' +
    "  |  _ \\\|  _ \\  / ___|  ___ _ __(_)_ __ | |_ " + '\n' +
    "  | |_) | |_) | \\___ \\ / __| '__| | '_ \\| __|" + '\n' +
    "  |  _ <|  __/   ___) | (__| |  | | |_) | |_ " + '\n' +
    "  |_| \\_\\_|     |____/ \\___|_|  |_| .__/ \\__|" + '\n' +
    "                                  |_|         " + '\n' +
    '  ******************************************** ')
    .usage('[filename] [options]');
commander_1.default
    .command('install [name]', 'install one or more packages').alias('i')
    .command('remove [name]', 'search with optional query').alias('r')
    .command('list', 'list packages installed').alias('l');
// program
// .command('list')
// .description('list current modules')
// .action(function(cmd){
//   console.log('list');
//   // let modCommand = new ModuleCommand();
//   // if(operation === 'list') console.log( modCommand.list() );
//   // else if(operation === 'install') modCommand.install(moduleNames);
//   // else if(operation === 'remove')modCommand.remove(moduleNames);
//   // else console.log('operation not found');
// })
// .command('install [moduleNames...]')
// .description('install module')
// .action(function(moduleNames,cmd){
//   let modCommand = new ModuleCommand();
//   console.log(moduleNames);
// })
// .command('remove [moduleNames...]')
// .description('remove module')
// .action(function(moduleNames,cmd){
//   let modCommand = new ModuleCommand();
//   console.log('remove');
// });
commander_1.default.parse(process.argv);
let filename = undefined;
let command = new exec_1.ExecCommand(ramda_1.default.pickBy((v, k) => v !== undefined, {
    outputTS: commander_1.default.skipOutputTS, linting: commander_1.default.skipLinting,
    outputDir: commander_1.default.outputDir, skipRun: commander_1.default.skipRun
}));
let hasRpsFile = ramda_1.default.any(arg => arg.indexOf('.rps') > 0, process.argv);
if (process.argv.length < 3) {
    commander_1.default.help();
}
else if (process.argv[2].indexOf('.rps') > 0) {
    filename = process.argv[2];
    command.run(filename);
}
else if (!hasRpsFile) {
}
process.on('unhandledRejection', (reason, promise) => {
    console.log('RPscript : Unhandled Rejection at:', reason.stack || reason);
    // Recommended: send the information to sentry.io
    // or whatever crash reporting service you use
});
